#pragma semicolon 1

#include <sourcemod>
#include <sdktools_functions>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP [AutoSilencer]",
	author	= "wS",
	version = "1.0.3"
};

#define ITEM_NAME "auto_silencer"

new bool:m_weaponMode;
new bool:g_bAccess[MAXPLAYERS + 1];

public OnPluginStart()
{
	decl String:game[48];
	GetGameFolderName(game, sizeof(game));
	if (strcmp(game, "cstrike", false)) {
		SetFailState("Plugin only for cs:s");
	}
	
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_TOGGLE)) {
		SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);
	}
	
	m_weaponMode = FindSendPropOffs("CWeaponM4A1", "m_weaponMode") > -1;
	HookEvent("item_pickup", item_pickup, EventHookMode_Post);
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_bAccess[client])
	{
		IntToString(1, ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	if (g_bAccess[client]) { return VGA_AlreadyEnabled; }
	SetStatus(client, true);
	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient) {
	SetStatus(client, false);
}

SetStatus(client, bool:enabled)
{
	g_bAccess[client] = enabled;
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, enabled);
}

///////////////////////////////////////////////////////////////////////////////////

public item_pickup(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (!g_bAccess[client]) {
		return;
	}
	
	decl String:sWeapon[32];
	GetEventString(event, "item", sWeapon, sizeof(sWeapon));
	
	if (!strcmp(sWeapon, "usp") || !strcmp(sWeapon, "m4a1"))
	{
		new weapon = GetPlayerWeaponSlot(client, sWeapon[0] == 'u' ? 1 : 0);
		if (weapon > MaxClients && GetEntityClassname(weapon, sWeapon, sizeof(sWeapon)) && (!strcmp(sWeapon[7], "usp") || !strcmp(sWeapon[7], "m4a1")))
		{
			SetEntProp(weapon, Prop_Send, "m_bSilencerOn", 1);
			if (m_weaponMode) { SetEntProp(weapon, Prop_Send, "m_weaponMode", 1); } // change sound
			if (weapon == GetEntPropEnt(client, Prop_Send, "m_hActiveWeapon"))
			{
				ClientCommand(client, "lastinv");
				CreateTimer(0.14, lastinv_again, client, TIMER_FLAG_NO_MAPCHANGE);
			}
		}
	}
}

public Action:lastinv_again(Handle:timer, any:client)
{
	if (IsClientInGame(client)) { ClientCommand(client, "lastinv"); }
	return Plugin_Stop;
}

public OnClientDisconnect(client) {
	g_bAccess[client] = false;
}